<?php
/*
Plugin Name: GD Pages Navigator
Plugin URI: http://blog.gdragon.info/wordpress/gd-pages-navigator
Description: This widget can be used to change the way of navigating through your blog pages.
Version: 1.00
Author: Milan Petrovic
Author URI: http://blog.gdragon.info/wordpress/
*/

/*
== Changelog ==

= Version: 1.0 / april 4 2008 =

* new: support for Wordpress 2.5

= Version: 0.60 / february 22 2008 =

* new: default title on top level page with no subpages
* edit: changes to widget control for more 2.4/2.5 adjusted look
* edit: more code cleanup
* fix: displaying parent level pages when page has no subpages

= Version: 0.50 / february 17 2008 =

* new: excluded pages as a select list
* edit: code cleanup
* fix: wrong widget title

= Version: 0.40 / february 17 2008 =

* new: excluded pages list
* new: support for multi level subpages
* new: go one level back item
* edit: small code reogranization
* fix: overriding widget title

*/

/*
Info:
* gdpnav_exclude_options: taken from flexi-pages-widget
*/

/*  Copyright 2007 Milan Petrovic (email : gdragon.work@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

function gdpnav_init()
{
	if ( !function_exists('register_sidebar_widget') || !function_exists('register_widget_control') ) return;
	
	function widget_gdpnav($args)
	{
        extract($args);
        global $post;

        $options = get_option('widget_gdpagesnavigator');
        $title = $options['title'];
        $filter = 'child_of='.$post->post_parent.'&depth=1';
        
        $levelTop = "";
        $levelBottom = "";
        $level = "";
        $ident = "";

        if (!is_page())
        {
            if ($options['blogRoot'] == 1)
                $filter = 'child_of=0&depth=1';
            else return;
        }
        else
        {
            $exclude = isset($options['excludePages']) ? explode(',', $options['excludePages']) : array(); 
            if (in_array($post->ID, $exclude)) return;
            $parent_page = get_post($post->post_parent);

            $subpages = gdpnav_get_count_subpages($post->ID);
            if ($subpages > 0)
                $filter = 'child_of='.$post->ID.'&depth=1';
            if ($options['autoTitle'] == 1 && $subpages > 0)
                $title = $post->post_title;
            if ($options['autoTitle'] == 1 && $subpages == 0)
                $title = $parent_page->post_title;
            if ($options['autoTitleExc'] == 1 && $subpages == 0 && $post->post_parent == 0)
                $title = $options['title'];

            if ($post->post_parent != 0 && $subpages == 0)
                $parent_page = get_post($parent_page->post_parent);
                
            if ($post->post_parent != 0)
            {
                if ($options["levelUp"] == 1)
                {
                    $level = '<ul><li class="page_item page-item-'.$parent_page->ID.'"><a href="'.get_page_link($parent_page->ID).'" title='.attribute_escape(apply_filters('the_title', $parent_page->post_title)).'>'.apply_filters('the_title', $parent_page->post_title).'</a></li></ul>';
                    if ($options["upLocTop"] == 0) $levelTop = $level;
                    else $levelBottom = $level;
                }
                if ($options["upIdent"] == 1) 
                    $ident = ' style="padding-left:15px"';
            }
        }
                
        $output = wp_list_pages('sort_column=menu_order&echo=0&title_li=&'.$filter);
        
        if (!empty($output)) 
        {
            echo $before_widget . $before_title . $title . $after_title;
            echo $levelTop;
            echo '<ul'.$ident.'>'.$output.'</ul>';
            echo $levelBottom;
            echo $after_widget; 
        }
	}
    
    function widget_gdpnav_control()
    {
        $options = get_option('widget_gdpagesnavigator');
        if (!is_array($options))
        {
            $options = array(
                'title'=>'Pages', 
                'autoTitle'=>1, 
                'autoTitleExc'=>1, 
                'blogRoot'=>1, 
                'emptyList'=>1, 
                'excludePages'=>'',
                'levelUp'=>0,
                'upLocTop'=>0,
                'upIdent'=>0
            );
        }
        
        if ($_POST['gdpnav-submit'])
        {
            $options['title'] = strip_tags(stripslashes($_POST['gdpnav-title']));
            $options['excludePages'] = isset($_REQUEST['gdpnav-excludePages']) ? implode(',', $_REQUEST['gdpnav-excludePages']) : ''; 
            $options['autoTitle'] = isset($_POST['gdpnav-autoTitle']);
            $options['autoTitleExc'] = isset($_POST['gdpnav-autoTitleExc']);
            $options['blogRoot'] = isset($_POST['gdpnav-blogRoot']);
            $options['emptyList'] = isset($_POST['gdpnav-emptyList']);
            $options['levelUp'] = isset($_POST['gdpnav-levelUp']);
            $options['upLocTop'] = isset($_POST['gdpnav-upLocTop']);
            $options['upIdent'] = isset($_POST['gdpnav-upIdent']);
            update_option('widget_gdpagesnavigator', $options);
        }
        
        if (isset($options['autoTitle']))
            $autoTitle = $options['autoTitle'] ? 'checked="checked"' : '';

        if (isset($options['autoTitleExc']))
            $autoTitleExc = $options['autoTitleExc'] ? 'checked="checked"' : '';

        if (isset($options['blogRoot']))
            $blogRoot = $options['blogRoot'] ? 'checked="checked"' : '';

        if (isset($options['emptyList']))
            $emptyList = $options['emptyList'] ? 'checked="checked"' : '';

        if (isset($options['levelUp']))
            $levelUp = $options['levelUp'] ? 'checked="checked"' : '';

        if (isset($options['upLocTop']))
            $upLocTop = $options['upLocTop'] ? 'checked="checked"' : '';

        if (isset($options['upIdent']))
            $upIdent = $options['upIdent'] ? 'checked="checked"' : '';

        $title = htmlspecialchars($options['title'], ENT_QUOTES);
        
?>
        <fieldset style="border: 1px grey solid; padding: 6px">
        <legend>Title:</legend>
            <label for="gdpnav-title">Default:</label>
            <br /><input style="width: 97%;" id="gdpnav-title" name="gdpnav-title" type="text" value="<?php echo $title; ?>" />
            <br /><label for="gdpnav-autoTitle" style="text-align:right;"><input class="checkbox" type="checkbox" <?php echo $autoTitle; ?> id="gdpnav-autoTitle" name="gdpnav-autoTitle" /> On subpages use parent name</label>
            <br /><label for="gdpnav-autoTitleExc" style="text-align:right;"><input class="checkbox" type="checkbox" <?php echo $autoTitleExc; ?> id="gdpnav-autoTitleExc" name="gdpnav-autoTitleExc" /> Use default name on top level page with no subpages</label>
        </fieldset>
        <fieldset style="border: 1px grey solid; padding: 6px">
        <legend>Exclude Pages:</legend>
            <select style="width: 100%;" name="gdpnav-excludePages[]" id="gdpnav-excludePages" multiple="multiple" size="5"><?php gdpnav_exclude_options("menu_order", "ASC", explode(',', $options['excludePages']),0,0) ?></select>
            <br /><span style="font-size:70%">use shift or ctrl to select more then one page</span>
        </fieldset>
        <fieldset style="border: 1px grey solid; padding: 6px">
        <legend>Display top level Pages on:</legend>
            <label for="gdpnav-blogRoot" style="text-align:right;"><input class="checkbox" type="checkbox" <?php echo $blogRoot; ?> id="gdpnav-blogRoot" name="gdpnav-blogRoot" /> Non-pages</label>
        </fieldset>
        <fieldset style="border: 1px grey solid; padding: 6px">
        <legend>Display parent level Pages on:</legend>
            <label for="gdpnav-emptyList" style="text-align:right;"><input class="checkbox" type="checkbox" <?php echo $emptyList; ?> id="gdpnav-emptyList" name="gdpnav-emptyList" /> Pages with no sub-pages</label>
        </fieldset>
        <fieldset style="border: 1px grey solid; padding: 6px">
        <legend>Additional level up item:</legend>
            <label for="gdpnav-levelUp" style="text-align:right;"><input class="checkbox" type="checkbox" <?php echo $levelUp; ?> id="gdpnav-levelUp" name="gdpnav-levelUp" /> Display on sub-pages level</label>
            <br />
            <div style="padding-left:20px">
                <label for="gdpnav-upLocTop" style="text-align:right;"><input class="checkbox" type="checkbox" <?php echo $upLocTop; ?> id="gdpnav-upLocTop" name="gdpnav-upLocTop" /> Go Level up item on bottom</label>
                <br />
                <label for="gdpnav-upIdent" style="text-align:right;"><input class="checkbox" type="checkbox" <?php echo $upIdent; ?> id="gdpnav-upIdent" name="gdpnav-upIdent" /> Display items idented</label>
            </div>
        </fieldset>
    	<br />
        <input type="hidden" id="gdpnav-submit" name="gdpnav-submit" value="1" />
        
<?php
    
    }

    function gdpnav_get_count_subpages($postId)
    {
        return count(gdpnav_get_subpages_id($postId));
    }
    
    function gdpnav_get_subpages_id($postId)
    {
        global $wpdb;
        $sql = "SELECT ID FROM ".$wpdb->posts." WHERE post_type = 'page' AND post_status = 'publish' AND post_parent = ".$postId;
        if($subpages = $wpdb->get_results($sql, ARRAY_A)) return $subpages;
        else return array();
    }
    
    function gdpnav_exclude_options($sort_column = "menu_order", $sort_order = "ASC", $selected = array(), $parent = 0, $level = 0)
    {
        global $wpdb;
        $items = $wpdb->get_results( "SELECT ID, post_parent, post_title FROM $wpdb->posts WHERE post_parent = $parent AND post_type = 'page' AND post_status = 'publish' ORDER BY {$sort_column} {$sort_order}" );

        if ( $items ) {
            foreach ( $items as $item ) {
                $pad = str_repeat( '&nbsp;', $level * 3 );
                if ( in_array($item->ID, $selected))
                    $current = ' selected="selected"';
                else
                    $current = '';
    
                echo "\n\t<option value='$item->ID'$current>$pad $item->post_title</option>";
                gdpnav_exclude_options( $sort_column, $sort_order, $selected, $item->ID,  $level +1 );
            }
        } else {
            return false;
        }
    }
    
	register_sidebar_widget(array('GD Pages Navigator', 'widgets'), 'widget_gdpnav');
    register_widget_control(array('GD Pages Navigator', 'widgets'), 'widget_gdpnav_control', 300, 470);
}

add_action('plugins_loaded', 'gdpnav_init');

?>